#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <linux/can.h>
#include <linux/can/raw.h>

void boot_can_config()
{
    system("ip link set can0 down");  
    system("ip link set can0 type can bitrate 500000");
    system("ip link set can0 up");                                                                              
}

void can_load_config(void)
{
    boot_can_config();
}

int System_Check(int result)
{
    if((-1 != result) && (WIFEXITED(result)) && (!(WEXITSTATUS(result))))
        return 0;
    else
        return -1;
}

int can_send()
{
	int s, nbytes;
	struct sockaddr_can addr;
	struct ifreq ifr;
	struct can_frame frame[2] = {{0}};
	s = socket(PF_CAN, SOCK_RAW, CAN_RAW);//create socket
	strcpy(ifr.ifr_name, "can0" );
	ioctl(s, SIOCGIFINDEX, &ifr); // can0
	addr.can_family = AF_CAN;
	addr.can_ifindex = ifr.ifr_ifindex;
	bind(s, (struct sockaddr *)&addr, sizeof(addr));//bind can0

	setsockopt(s, SOL_CAN_RAW, CAN_RAW_FILTER, NULL, 0);

	frame[0].can_id = 0x19B;
	frame[0].can_dlc = 8;

	frame[0].data[0] = 'B';
	frame[0].data[1] = 'I';
	frame[0].data[2] = 'O';
	frame[0].data[3] = 'K';
	frame[0].data[4] = '!';
	frame[0].data[5] = '!';
	frame[0].data[6] = '!';
	frame[0].data[7] = '!';
	
	while(1)
	{
		//send can frame
		nbytes = write(s, &frame[0], sizeof(frame[0])); //send frame[0]
		if(nbytes != sizeof(frame[0]))
		{
			printf("Send Error frame[0]\n!");
		}
		usleep(2000);		//2ms
	}
	close(s);
	return 0;
}

int main()
{
	can_load_config();

	can_send();

	return 0;
}